;============================================================================
;
; x3dos example program #2
;
; - View Registers -
;
;============================================================================

;============================================================================
; Pull in standard preprocs
;============================================================================

include 'STDAFX.INC'

;============================================================================
; Macro for printing AX register
;============================================================================

macro PrintRegister r {
        mov     word[g_Format],`r
        mov     ax,r
        call    PrintHex
}

;============================================================================
; Program entry point
;============================================================================

        ;====================================================================
        ; All string instructions assume forward
        ;====================================================================

        cld	; DF=0

        ;====================================================================
        ; Setup 80x25 text video mode with fresh screen
        ;====================================================================

        mov     ax,VIDEOMODE_TEXT
        call    SetVideoMode

        ;====================================================================
        ; Setup text and background printing colors
        ;====================================================================

        mov     bl,TEXTCOLOR_WHITE
        call    SetTextColor

        mov     bl,BKGNDCOLOR_BLACK
        call    SetBkgndColor

	;====================================================================
	; Setup work area for clearing and scrolling
	;====================================================================

	mov	cl,0	; Left
	mov	ch,0	; Top
	mov	dl,79	; Right
	mov	dh,24	; Bottom
	call	SetWorkArea

        ;====================================================================
        ; Print special registers
        ;====================================================================

        PrintRegister CS        ; UPPERCASE
        PrintRegister ds        ; lowercase
        PrintRegister es
        PrintRegister fs
        PrintRegister gs
        PrintRegister ss
        PrintRegister sp

        ;====================================================================
        ; Wait for keystroke and quit
        ;====================================================================

        call    SystemPause
        call    ExitProgram

;============================================================================
;
; PrintHex
;
; Input: AX = data
;
;============================================================================

PrintHex:
        pusha
        mov     di,g_Format+5
        mov     si,ax
        mov     cx,4
        rol     si,cl
    .FormatLoop:
        mov     ax,si
        and     al,0x0F
        mov     bx,g_HexTable
        xlatb
        stosb
        rol     si,4
        loop    .FormatLoop
        mov     si,g_Format
        call    PrintString
        popa
        ret

;============================================================================
; Data starts here
;============================================================================

    times 4096 db 0 ; Ensure that long files are loaded normally!

    g_HexTable db '0123456789ABCDEF'
    g_Format   db '?? 0x????\n',0
