;============================================================================
;
; STDAFX.INC
;
; Preprocs for system kernel and user programs
;
;============================================================================

;============================================================================
;
; Select output format
;
;============================================================================

if defined SYSTEM_BUILD
format binary as 'SYS'          ; Make binary .SYS file
else
format binary as 'X3D'          ; Make binary .X3D file
end if

;============================================================================
;
; Equates: SetVideoMode
;          GetVideoMode
;
;============================================================================

VIDEOMODE_TEXT          fix 0x0003
VIDEOMODE_GRAPHIC       fix 0x0013

;============================================================================
;
; Equates: SetTextColor
;          GetTextColor
;
; Text mode only!
;
;============================================================================

TEXTCOLOR_BLACK         fix 00000000b
TEXTCOLOR_BLUE          fix 00000001b
TEXTCOLOR_GREEN         fix 00000010b
TEXTCOLOR_CYAN          fix 00000011b
TEXTCOLOR_RED           fix 00000100b
TEXTCOLOR_MAGENTA       fix 00000101b
TEXTCOLOR_BROWN         fix 00000110b
TEXTCOLOR_LIGHTGRAY     fix 00000111b
TEXTCOLOR_DARKGRAY      fix 00001000b
TEXTCOLOR_LIGHTBLUE     fix 00001001b
TEXTCOLOR_LIGHTGREEN    fix 00001010b
TEXTCOLOR_LIGHTCYAN     fix 00001011b
TEXTCOLOR_LIGHTRED      fix 00001100b
TEXTCOLOR_LIGHTMAGENTA  fix 00001101b
TEXTCOLOR_YELLOW        fix 00001110b
TEXTCOLOR_WHITE         fix 00001111b

;============================================================================
;
; Equates: SetBkgndColor
;          GetBkgndColor
;
; Text mode only!
;
;============================================================================

BKGNDCOLOR_BLACK        fix 00000000b
BKGNDCOLOR_BLUE         fix 00010000b
BKGNDCOLOR_GREEN        fix 00100000b
BKGNDCOLOR_CYAN         fix 00110000b
BKGNDCOLOR_RED          fix 01000000b
BKGNDCOLOR_MAGENTA      fix 01010000b
BKGNDCOLOR_BROWN        fix 01100000b
BKGNDCOLOR_LIGHTGRAY    fix 01110000b

;============================================================================
;
; Equates: SetCaretStyle (Not Implemented Yet)
;          GetCaretStyle (Not Implemented Yet)
;
; Text mode only!
;
;============================================================================

CARETSTYLE_STD          fix 0000011000000111b
CARETSTYLE_BOX          fix 0000000000000111b
CARETSTYLE_VISIBLE      fix 0000000000000000b   ; DEFAULT = 0
CARETSTYLE_HIDDEN       fix 0010000000000000b

;============================================================================
;
; Equates: CheckKeyStroke
;          GetKeyStroke
;
;============================================================================

KEYCODE_ESCAPE          fix 0x1B

SCANCODE_BACKSPACE	fix 0x08
SCANCODE_RETURN		fix 0x0D

SCANCODE_LEFT           fix 0x4B
SCANCODE_RIGHT          fix 0x4D
SCANCODE_HOME           fix 0x47
SCANCODE_UP             fix 0x48
SCANCODE_END            fix 0x4F
SCANCODE_DOWN           fix 0x50

;============================================================================
;
; Equates: GetShiftFlags (Not Implemented Yet)
;
;============================================================================

SHIFTFLAG_NONE          fix 00000000b
SHIFTFLAG_INSERT        fix 10000000b
SHIFTFLAG_CAPSLOCK      fix 01000000b
SHIFTFLAG_NUMLOCK       fix 00100000b
SHIFTFLAG_SCROLLLOCK    fix 00010000b
SHIFTFLAG_ALT           fix 00001000b
SHIFTFLAG_CTRL          fix 00000100b
SHIFTFLAG_LSHIFT        fix 00000010b
SHIFTFLAG_RSHIFT        fix 00000001b

;============================================================================
;
; API Imports for user programs
;
;============================================================================

if ~defined SYSTEM_BUILD

SetVideoMode              fix 0x0050:0x0103
SetTextColor              fix 0x0050:0x0106
GetTextColor              fix 0x0050:0x0109
SetBkgndColor             fix 0x0050:0x010C
GetBkgndColor             fix 0x0050:0x010F
SetWorkArea               fix 0x0050:0x0112
GetWorkArea               fix 0x0050:0x0115
ScrollWorkArea            fix 0x0050:0x0118
ClearWorkArea             fix 0x0050:0x011B
SetCaretPos               fix 0x0050:0x011E
GetCaretPos               fix 0x0050:0x0121
IncCaretPos               fix 0x0050:0x0124
DecCaretPos               fix 0x0050:0x0127
PutChar                   fix 0x0050:0x012A
PrintChar                 fix 0x0050:0x012D
PrintBuffer               fix 0x0050:0x0130
PrintCrlf                 fix 0x0050:0x0133
PrintPbcd                 fix 0x0050:0x0136
UnpackPbcd                fix 0x0050:0x0139
PbcdToAscii               fix 0x0050:0x013C
CheckForKey               fix 0x0050:0x013F
WaitForKey                fix 0x0050:0x0142
SystemPause               fix 0x0050:0x0145
ExitProgram               fix 0x0050:0x0148
PrintString               fix 0x0050:0x014B

end if

;============================================================================
;
; Code size and entry offset for kernel and user programs
;
;============================================================================

use16
org 0x0100

;============================================================================
; Yay!
;============================================================================
